-- ----------------------------
-- 单事项审批人员表
-- ----------------------------
DROP TABLE IF EXISTS `mortals_sys_approver`;
CREATE TABLE mortals_sys_approver(
    `id` bigint(20)   AUTO_INCREMENT   COMMENT '序号，主键，自增长',
    `siteId` bigint(20)      COMMENT '站点id',
    `fullName` varchar(64) NOT NULL     COMMENT '工作人员姓名',
    `phoneNumber` varchar(128) NOT NULL     COMMENT '联系电话',
    `loginName` varchar(128)      COMMENT '登录用户名',
    `loginPwd` varchar(128)      COMMENT '登录密码',
    `deptId` bigint(20)      COMMENT '所属部门',
    `deptCode` varchar(128)      COMMENT '所属部门编码',
    `deptName` varchar(128)      COMMENT '所属部门名称',
    `remarks` varchar(255)      COMMENT '备注',
    `createUserId` bigint(20)  COMMENT '创建用户',
    `createTime` datetime  COMMENT '创建时间',
    `updateUserId` bigint(20)      COMMENT '更新用户',
    `updateTime` datetime      COMMENT '更新时间',
PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='单事项审批人员';
-- ----------------------------
-- 单事项申报表
-- ----------------------------
DROP TABLE IF EXISTS `mortals_sys_matter_apply`;
CREATE TABLE mortals_sys_matter_apply(
    `id` bigint(20)   AUTO_INCREMENT   COMMENT '序号，主键，自增长',
    `siteId` bigint(20)      COMMENT '站点id',
    `singleMatterId` bigint(20)      COMMENT '单事项id',
    `matterId` bigint(20)      COMMENT '基础事项id',
    `deptCode` varchar(128)      COMMENT '部门编码',
    `matterName` varchar(128) NOT NULL     COMMENT '单事项名称',
    `applyPerson` varchar(128)      COMMENT '申请人姓名',
    `sexual` tinyint(2)    DEFAULT '1'  COMMENT '申请人性别',
    `phoneNum` varchar(128)      COMMENT '申请人电话',
    `idCard` varchar(128)      COMMENT '申请人身份证号码',
    `address` varchar(128)      COMMENT '地点',
    `applyType` tinyint(2)    DEFAULT '1'  COMMENT '申请方式1移动端2后台',
    `applyTime` datetime      COMMENT '申请时间',
    `applyState` tinyint(2)    DEFAULT '0'  COMMENT '审批状态0审批中1通过2不通过',
    `advisement` varchar(255)      COMMENT '审批意见',
    `remarks` varchar(255)      COMMENT '备注',
    `openId` varchar(128)      COMMENT '微信openId',
    `createUserId` bigint(20)      COMMENT '创建用户',
    `createTime` datetime      COMMENT '创建时间',
    `updateUserId` bigint(20)      COMMENT '更新用户',
    `updateTime` datetime      COMMENT '更新时间',
PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='单事项申报';

-- ----------------------------
-- 事项申报材料表
-- ----------------------------
DROP TABLE IF EXISTS `mortals_sys_matter_apply_datum`;
CREATE TABLE mortals_sys_matter_apply_datum(
    `id` bigint(20)   AUTO_INCREMENT   COMMENT '序号，主键，自增长',
    `siteId` bigint(20)      COMMENT '站点id',
    `applyId` bigint(20)      COMMENT '用户申报id',
    `singleMatterId` bigint(20)      COMMENT '单事项id',
    `matterId` bigint(20)      COMMENT '基础事项id',
    `datumId` bigint(20)      COMMENT '材料id',
    `materialName` varchar(1024)     COMMENT '材料名称',
    `fileName` varchar(128)      COMMENT '附件文件名称',
    `fileUrl` varchar(255)      COMMENT '附件文件地址',
    `createUserId` bigint(20)      COMMENT '创建用户',
    `createTime` datetime      COMMENT '创建时间',
    `updateUserId` bigint(20)      COMMENT '更新用户',
    `updateTime` datetime      COMMENT '更新时间',
PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='事项申报材料';

INSERT INTO `mortals_xhx_param` (`name`, `firstOrganize`, `secondOrganize`, `paramKey`, `paramValue`, `validStatus`, `modStatus`, `displayType`, `remark`, `createTime`, `createUserId`, `createUserName`) VALUES ('申请方式', 'MatterApply', 'applyType', '1', '移动端', '1', '4', '0', 'applyType', NULL, NULL, NULL);
INSERT INTO `mortals_xhx_param` (`name`, `firstOrganize`, `secondOrganize`, `paramKey`, `paramValue`, `validStatus`, `modStatus`, `displayType`, `remark`, `createTime`, `createUserId`, `createUserName`) VALUES ('申请方式', 'MatterApply', 'applyType', '2', '后台', '1', '4', '0', 'applyType', NULL, NULL, NULL);

INSERT INTO `mortals_xhx_param` (`name`, `firstOrganize`, `secondOrganize`, `paramKey`, `paramValue`, `validStatus`, `modStatus`, `displayType`, `remark`, `createTime`, `createUserId`, `createUserName`) VALUES ('审批状态', 'MatterApply', 'applyState', '0', '审批中', '1', '4', '0', 'applyState', NULL, NULL, NULL);
INSERT INTO `mortals_xhx_param` (`name`, `firstOrganize`, `secondOrganize`, `paramKey`, `paramValue`, `validStatus`, `modStatus`, `displayType`, `remark`, `createTime`, `createUserId`, `createUserName`) VALUES ('审批状态', 'MatterApply', 'applyState', '1', '通过', '1', '4', '0', 'applyState', NULL, NULL, NULL);
INSERT INTO `mortals_xhx_param` (`name`, `firstOrganize`, `secondOrganize`, `paramKey`, `paramValue`, `validStatus`, `modStatus`, `displayType`, `remark`, `createTime`, `createUserId`, `createUserName`) VALUES ('审批状态', 'MatterApply', 'applyState', '2', '不通过', '1', '4', '0', 'applyState', NULL, NULL, NULL);

INSERT INTO `mortals_xhx_param` (`name`, `firstOrganize`, `secondOrganize`, `paramKey`, `paramValue`, `validStatus`, `modStatus`, `displayType`, `remark`, `createTime`, `createUserId`, `createUserName`) VALUES ('性别', 'MatterApply', 'sexual', '1', '男', '1', '4', '0', 'sexual', NULL, NULL, NULL);
INSERT INTO `mortals_xhx_param` (`name`, `firstOrganize`, `secondOrganize`, `paramKey`, `paramValue`, `validStatus`, `modStatus`, `displayType`, `remark`, `createTime`, `createUserId`, `createUserName`) VALUES ('性别', 'MatterApply', 'sexual', '2', '女', '1', '4', '0', 'sexual', NULL, NULL, NULL);
