package com.mortals.xhx.daemon;

import cn.hutool.setting.Setting;
import com.google.common.collect.BiMap;
import com.mortals.framework.common.Rest;
import com.mortals.framework.util.ThreadPool;
import com.mortals.xhx.common.pdu.ApiRespPdu;
import com.mortals.xhx.common.utils.SyncDeptThread;
import com.mortals.xhx.common.utils.SyncTreeMatterThread;
import com.mortals.xhx.module.dept.service.DeptService;
import com.mortals.xhx.module.matter.service.MatterService;
import lombok.extern.apachecommons.CommonsLog;
import org.checkerframework.checker.units.qual.A;
import org.checkerframework.checker.units.qual.K;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * 事项数据同步更新
 *
 * @author: zxfei
 * @date: 2022/3/30 9:45
 */
@CommonsLog
@RestController
@RequestMapping("test")
public class RequestDataController {

    @Autowired
    private MatterService matterService;
    @Autowired
    private DeptService deptService;

    /**
     * 生成基础数据prop
     *
     * @return
     */
    @PostMapping("/baseprop")
    public ApiRespPdu<String> baseprop() {
        ApiRespPdu<String> respPdu = new ApiRespPdu<>();

        Map<String, String> baseInfoMap = matterService.getBaseInfoMap(null);
        //保存为
        Setting setting = Setting.create();
        setting.putAll(baseInfoMap);
        setting.store("E://baseinfo.setting");
        Map<String, String> sqclInfoMap = matterService.getSqclInfoMap(null);
        sqclInfoMap.entrySet().stream().peek(item -> {
            String[] split = item.getValue().split(",");
            if (split.length > 1) {
                StringBuffer sb = new StringBuffer();
                for (int i = 0; i < split.length; i++) {
                    sb.append(split[i]);
                    sb.append(".");
                    sb.append(split[i]);
                    if (i != split.length - 1) {
                        sb.append(",");
                    }

                }
                item.setValue(sb.toString());
            }
        }).count();

        setting = Setting.create();
        setting.putAll(sqclInfoMap);
        setting.store("E://sqclinfo.setting");
        return respPdu;
    }

    /**
     * 同步部门数据
     *
     * @return
     */
    @GetMapping("/syncDept")
    public Rest<String> syncDept() {
        //ThreadPool.getInstance().execute(new SyncDeptThread(deptService));
        return Rest.ok("接收同步部门成功");
    }


    /**
     * 同步事项数据
     *
     * @return
     */
    @GetMapping("/syncMatter")
    public Rest<String> syncMatter() {
       // ThreadPool.getInstance().execute(new SyncTreeMatterThread(matterService));
        return Rest.ok("接收同步成功");
    }

    private void checkKeyValue(BiMap<String, String> map, Map.Entry<String, Object> m, String value) {
        if ("0".equals(value)) {
            //查看是否为空
            String temp = map.get(m.getValue().toString());
            if (ObjectUtils.isEmpty(temp)) {
                //打印枚举类型值
                System.out.println("uncheck name:" + m.getKey() + " value:" + m.getValue());
            }
        }
    }


    public static void main(String[] args) {


    }

}
