package com.mortals.xhx.module.app.model;

import java.util.List;
import java.util.ArrayList;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.mortals.framework.annotation.Excel;
import com.mortals.framework.model.BaseEntityLong;
import com.mortals.xhx.module.app.model.vo.AppInfoTempleteFieldVo;
/**
 * 自助终端应用模板信息字段实体对象
 *
 * @author zxfei
 * @date 2022-12-02
 */

public class AppInfoTempleteFieldEntity extends AppInfoTempleteFieldVo {
    private static final long serialVersionUID = 1L;

    /**
     * 应用id
     */
    private Long appId;
    /**
     * 字段编码
     */
    private String fieldCode;
    /**
     * 字段名称
     */
    private String fieldName;
    /**
     * 字段类型（input.单行输入框,textarea.多行输入框,SELECT.下拉选项框,date.日期选择框,editer.富文本）
     */
    private String fieldType;
    /**
     * 数据类型（number.数字,string.字符串）
     */
    private String dataType;
    /**
     * 字段值
     */
    private String fieldValue;
    /**
     * 数据长度，默认128
     */
    private Integer fieldLen;
    /**
     * 是否允许为空，(0.否,1.是)
     */
    private Integer fieldNull;
    /**
     * 字段是否列表显示(0.否,1.是)
     */
    private Integer isList;
    /**
     * 排序号
     */
    private Integer fieldOrderNo;
    /**
     * 备注
     */
    private String remark;



    public AppInfoTempleteFieldEntity(){}
    /**
     * 获取 应用id
     * @return Long
     */
    public Long getAppId(){
        return appId;
    }
    /**
     * 设置 应用id
     * @param appId
     */
    public void setAppId(Long appId){
        this.appId = appId;
    }
    /**
     * 获取 字段编码
     * @return String
     */
    public String getFieldCode(){
        return fieldCode;
    }
    /**
     * 设置 字段编码
     * @param fieldCode
     */
    public void setFieldCode(String fieldCode){
        this.fieldCode = fieldCode;
    }
    /**
     * 获取 字段名称
     * @return String
     */
    public String getFieldName(){
        return fieldName;
    }
    /**
     * 设置 字段名称
     * @param fieldName
     */
    public void setFieldName(String fieldName){
        this.fieldName = fieldName;
    }
    /**
     * 获取 字段类型（input.单行输入框,textarea.多行输入框,SELECT.下拉选项框,date.日期选择框,editer.富文本）
     * @return String
     */
    public String getFieldType(){
        return fieldType;
    }
    /**
     * 设置 字段类型（input.单行输入框,textarea.多行输入框,SELECT.下拉选项框,date.日期选择框,editer.富文本）
     * @param fieldType
     */
    public void setFieldType(String fieldType){
        this.fieldType = fieldType;
    }
    /**
     * 获取 数据类型（number.数字,string.字符串）
     * @return String
     */
    public String getDataType(){
        return dataType;
    }
    /**
     * 设置 数据类型（number.数字,string.字符串）
     * @param dataType
     */
    public void setDataType(String dataType){
        this.dataType = dataType;
    }
    /**
     * 获取 字段值
     * @return String
     */
    public String getFieldValue(){
        return fieldValue;
    }
    /**
     * 设置 字段值
     * @param fieldValue
     */
    public void setFieldValue(String fieldValue){
        this.fieldValue = fieldValue;
    }
    /**
     * 获取 数据长度，默认128
     * @return Integer
     */
    public Integer getFieldLen(){
        return fieldLen;
    }
    /**
     * 设置 数据长度，默认128
     * @param fieldLen
     */
    public void setFieldLen(Integer fieldLen){
        this.fieldLen = fieldLen;
    }
    /**
     * 获取 是否允许为空，(0.否,1.是)
     * @return Integer
     */
    public Integer getFieldNull(){
        return fieldNull;
    }
    /**
     * 设置 是否允许为空，(0.否,1.是)
     * @param fieldNull
     */
    public void setFieldNull(Integer fieldNull){
        this.fieldNull = fieldNull;
    }
    /**
     * 获取 字段是否列表显示(0.否,1.是)
     * @return Integer
     */
    public Integer getIsList(){
        return isList;
    }
    /**
     * 设置 字段是否列表显示(0.否,1.是)
     * @param isList
     */
    public void setIsList(Integer isList){
        this.isList = isList;
    }
    /**
     * 获取 排序号
     * @return Integer
     */
    public Integer getFieldOrderNo(){
        return fieldOrderNo;
    }
    /**
     * 设置 排序号
     * @param fieldOrderNo
     */
    public void setFieldOrderNo(Integer fieldOrderNo){
        this.fieldOrderNo = fieldOrderNo;
    }
    /**
     * 获取 备注
     * @return String
     */
    public String getRemark(){
        return remark;
    }
    /**
     * 设置 备注
     * @param remark
     */
    public void setRemark(String remark){
        this.remark = remark;
    }




    @Override
    public int hashCode() {
        return this.getId().hashCode();
    }
    @Override
    public boolean equals(Object obj) {
        if (obj == null) return false;
        if (obj instanceof AppInfoTempleteFieldEntity) {
            AppInfoTempleteFieldEntity tmp = (AppInfoTempleteFieldEntity) obj;
            if (this.getId() == tmp.getId()) {
                return true;
            }
        }
        return false;
    }

    public String toString(){
        StringBuilder sb = new StringBuilder("");
        sb.append(",appId:").append(getAppId());
        sb.append(",fieldCode:").append(getFieldCode());
        sb.append(",fieldName:").append(getFieldName());
        sb.append(",fieldType:").append(getFieldType());
        sb.append(",dataType:").append(getDataType());
        sb.append(",fieldValue:").append(getFieldValue());
        sb.append(",fieldLen:").append(getFieldLen());
        sb.append(",fieldNull:").append(getFieldNull());
        sb.append(",isList:").append(getIsList());
        sb.append(",fieldOrderNo:").append(getFieldOrderNo());
        sb.append(",remark:").append(getRemark());
        return sb.toString();
    }

    public void initAttrValue(){

        this.appId = null;

        this.fieldCode = "";

        this.fieldName = "";

        this.fieldType = "";

        this.dataType = "";

        this.fieldValue = "";

        this.fieldLen = 0;

        this.fieldNull = 1;

        this.isList = 0;

        this.fieldOrderNo = 1;

        this.remark = "";
    }
}