package com.mortals.xhx.module.apply.web;
import com.mortals.framework.annotation.RepeatSubmit;
import com.mortals.framework.annotation.UnAuth;
import com.mortals.framework.common.Rest;
import com.mortals.framework.model.BaseEntity;
import com.mortals.framework.model.PageInfo;
import com.mortals.framework.model.Result;
import com.mortals.framework.service.IUser;
import com.mortals.framework.util.DateUtils;
import com.mortals.framework.utils.BeanUtil;
import com.mortals.framework.utils.ReflectUtils;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.module.apply.model.MatterApplyDatumEntity;
import com.mortals.xhx.module.apply.model.MatterApplyDatumQuery;
import com.mortals.xhx.module.apply.service.MatterApplyDatumService;
import lombok.Getter;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.apply.model.MatterApplyEntity;
import com.mortals.xhx.module.apply.service.MatterApplyService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;

import java.io.*;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.util.*;
import java.util.stream.Collectors;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

import com.alibaba.fastjson.JSONObject;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import static com.mortals.framework.ap.SysConstains.*;
/**
*
* 单事项申报
*
* @author zxfei
* @date 2023-05-23
*/
@RestController
@RequestMapping("matter/apply")
public class MatterApplyController extends BaseCRUDJsonBodyMappingController<MatterApplyService,MatterApplyEntity,Long> {

    @Autowired
    private ParamService paramService;
    @Autowired
    private MatterApplyDatumService matterApplyDatumService;

    @Value("${upload.path}")
    @Getter
    private String filePath;

    public MatterApplyController(){
        super.setModuleDesc( "单事项申报");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "applyType", paramService.getParamBySecondOrganize("MatterApply","applyType"));
        this.addDict(model, "applyState", paramService.getParamBySecondOrganize("MatterApply","applyState"));
        this.addDict(model, "sexual", paramService.getParamBySecondOrganize("MatterApply","sexual"));
        super.init(model, context);
    }

    @PostMapping({"save"})
    @RepeatSubmit
    @UnAuth
    public String save(@RequestBody MatterApplyEntity entity) {
        Map<String, Object> model = new HashMap();
        Context context = this.getContext();
        String busiDesc = "保存" + this.getModuleDesc();

        int code;
        try {
            this.saveBefore(entity, model, context);
            if (entity.newEntity()) {
                Class<MatterApplyEntity> tClass = ReflectUtils.getClassGenricType(this.getClass(), 1);
                MatterApplyEntity initEntity = (MatterApplyEntity)tClass.newInstance();
                initEntity.initAttrValue();
                BeanUtils.copyProperties(entity, initEntity, BeanUtil.getNullPropertyNames(entity));
                entity = initEntity;
                busiDesc = "新增" + this.getModuleDesc();
                initEntity.setCreateTime(new Date());
                initEntity.setUpdateTime(initEntity.getCreateTime());
                IUser user = this.getCurUser();
                if (user != null) {
                    initEntity.setCreateUserId(user.getId());
                    initEntity.setCreateUser(user.getLoginName());
                    initEntity.setCreateUserName(user.getRealName());
                    initEntity.setCreateUserDeptId(user.getDeptId());
                    initEntity.setCreateUserDeptName(user.getDeptName());
                    initEntity.setUpdateUserId(user.getId());
                    initEntity.setUpdateUser(user.getLoginName());
                    initEntity.setUpdateUserName(user.getRealName());
                    initEntity.setUpdateUserDeptId(user.getDeptId());
                    initEntity.setUpdateUserDeptName(user.getDeptName());
                }

                this.service.save(initEntity, context);
            } else {
                busiDesc = "修改" + this.getModuleDesc();
                entity.setUpdateTime(new Date());
                IUser user = this.getCurUser();
                if (user != null) {
                    entity.setUpdateUserId(user.getId());
                    entity.setUpdateUser(user.getLoginName());
                    entity.setUpdateUserName(user.getRealName());
                    entity.setUpdateUserDeptId(user.getDeptId());
                    entity.setUpdateUserDeptName(user.getDeptName());
                }

                this.service.update(entity, context);
            }

            model.put("id", entity.getId());
            code = this.saveAfter(entity, model, context);
            model.put("entity", entity);
            model.put("message_info", busiDesc + "成功");
            this.recordSysLog(this.request, busiDesc + " 【成功】 [id:" + entity.getId() + "]");
        } catch (Exception var9) {
            this.doException(this.request, busiDesc, model, var9);
            model.put("entity", entity);
            this.init(model, context);
            code = this.saveException(entity, model, context, var9);
        }

        this.init(model, context);
        JSONObject ret = new JSONObject();
        ret.put("code", code);
        ret.put("msg", model.remove("message_info"));
        ret.put("data", model);
        return ret.toJSONString();
    }

    /**
     * 审批
     * @param entity
     * @return
     */
    @PostMapping({"examine"})
    public String applyExamine(@RequestBody MatterApplyEntity entity) {
        Map<String, Object> model = new HashMap();
        Context context = this.getContext();
        String busiDesc = "审批" + this.getModuleDesc();

        int code;
        try {
            this.service.applyExamine(entity,context);
            model.put("id", entity.getId());
            code = this.saveAfter(entity, model, context);
            model.put("entity", entity);
            model.put("message_info", busiDesc + "成功");
            this.recordSysLog(this.request, busiDesc + " 【成功】 [id:" + entity.getId() + "]");
        } catch (Exception var9) {
            this.doException(this.request, busiDesc, model, var9);
            model.put("entity", entity);
            this.init(model, context);
            code = this.saveException(entity, model, context, var9);
        }

        this.init(model, context);
        JSONObject ret = new JSONObject();
        ret.put("code", code);
        ret.put("msg", model.remove("message_info"));
        ret.put("data", model);
        return ret.toJSONString();
    }

    /**
     * 批量审批
     * @param entity
     * @return
     */
    @PostMapping({"examine/batch"})
    public String applyExamineBatch(@RequestBody MatterApplyEntity entity) {
        Map<String, Object> model = new HashMap();
        Context context = this.getContext();
        String busiDesc = "审批" + this.getModuleDesc();

        int code;
        try {
            this.service.applyExamineBatch(entity,context);
            model.put("id", entity.getId());
            code = this.saveAfter(entity, model, context);
            model.put("entity", entity);
            model.put("message_info", busiDesc + "成功");
            this.recordSysLog(this.request, busiDesc + " 【成功】 [id:" + entity.getId() + "]");
        } catch (Exception var9) {
            this.doException(this.request, busiDesc, model, var9);
            model.put("entity", entity);
            this.init(model, context);
            code = this.saveException(entity, model, context, var9);
        }

        this.init(model, context);
        JSONObject ret = new JSONObject();
        ret.put("code", code);
        ret.put("msg", model.remove("message_info"));
        ret.put("data", model);
        return ret.toJSONString();
    }

    /**
     * 重新申请
     * @param entity
     * @return
     */
    @PostMapping({"reApply"})
    @RepeatSubmit
    @UnAuth
    public String reApply(@RequestBody MatterApplyEntity entity) {
        Map<String, Object> model = new HashMap();
        Context context = this.getContext();
        String busiDesc = "重新申请" + this.getModuleDesc();

        int code;
        try {
            this.service.reApply(entity,context);
            model.put("id", entity.getId());
            code = this.saveAfter(entity, model, context);
            model.put("entity", entity);
            model.put("message_info", busiDesc + "成功");
            this.recordSysLog(this.request, busiDesc + " 【成功】 [id:" + entity.getId() + "]");
        } catch (Exception var9) {
            this.doException(this.request, busiDesc, model, var9);
            model.put("entity", entity);
            this.init(model, context);
            code = this.saveException(entity, model, context, var9);
        }

        this.init(model, context);
        JSONObject ret = new JSONObject();
        ret.put("code", code);
        ret.put("msg", model.remove("message_info"));
        ret.put("data", model);
        return ret.toJSONString();
    }

    @RequestMapping(
            value = {"delete"},
            method = {RequestMethod.POST, RequestMethod.GET}
    )
    @UnAuth
    public String delete(Long[] id) {
        Context context = this.getContext();
        if (id == null) {
            return this.createFailJsonResp("请至少选择一条记录");
        } else {
            Map<String, Object> model = new HashMap();
            int code = 1;
            String busiDesc = "删除" + this.getModuleDesc();

            try {
                this.deleteBefore(id, context);
                int iRet = this.service.remove(id, context);
                model.put("message_info", this.getModuleDesc() + "删除成功!删除条数:" + iRet);
                this.recordSysLog(this.request, busiDesc + " 【成功】 [id:" + StringUtils.converArray2Str(id) + "]");
            } catch (Exception var7) {
                code = -1;
                this.doException(this.request, busiDesc, model, var7);
            }

            JSONObject ret = new JSONObject();
            ret.put("code", Integer.valueOf(code));
            ret.put("msg", model.remove("message_info"));
            ret.put("data", model);
            return ret.toJSONString();
        }
    }

    @PostMapping({"list"})
    @UnAuth
    public Rest<Object> list(@RequestBody MatterApplyEntity query) {
        Rest<Object> ret = new Rest();
        Map<String, Object> model = new HashMap();
        Context context = this.getContext();
        String busiDesc = "查询" + this.getModuleDesc();

        int code;
        try {
            this.doListBefore(query, model, context);
            PageInfo pageInfo = this.buildPageInfo(query);
            Result<MatterApplyEntity> result = this.getService().find(query, pageInfo, context);
            this.doListAfter(query, result.getList(), context);
            model.put("data", result.getList());
            model.put("pageInfo", result.getPageInfo());
            this.parsePageInfo(model, result.getPageInfo());
            code = this.doListAfter(query, (Map)model, context);
            model.put("message_info", busiDesc + "成功");
            this.recordSysLog(this.request, busiDesc + " 【成功】");
        } catch (Exception var9) {
            code = -1;
            this.doException(this.request, busiDesc, model, var9);
        }

        this.init(model, context);
        ret.setCode(code);
        ret.setData(model);
        ret.setDict(model.get("dict"));
        ret.setMsg(model.get("message_info") == null ? "" : model.remove("message_info").toString());
        return ret;
    }


    @PostMapping(value = "download/matter/file")
    public void downloadFile(@RequestBody MatterApplyDatumEntity query) {
        List<MatterApplyDatumEntity> datumEntityList = matterApplyDatumService.find(query);
        //List<String> fileList = splitToLong(ids);
        batchDownloadFile(datumEntityList, request, response);
    }

    @PostMapping(value = "download/all/file")
    public void downloadAllFile(@RequestBody MatterApplyEntity query) {
        List<MatterApplyDatumEntity> datumEntityList = matterApplyDatumService.find(new MatterApplyDatumQuery().applyId(query.getId()));
        //List<String> fileList = splitToLong(ids);
        batchDownloadFile(datumEntityList, request, response);
    }

    /**
     * 批量下载文件
     *
     * @param list     批量文件下载路径集合
     * @param request  request
     * @param response response
     */
    private void batchDownloadFile(List<MatterApplyDatumEntity> list, HttpServletRequest request, HttpServletResponse response) {
        //设置响应头信息
        //response.reset();
        response.setCharacterEncoding("utf-8");
        response.setContentType("multipart/form-data");
        //设置压缩包的名字，date为时间戳
        String date = DateUtils.getCurrDateTime("yyyyMMddHHmmss");
        String downloadName = "压缩包" + date + ".zip";
        //返回客户端浏览器的版本号、类型
        String agent = request.getHeader("USER-AGENT");
        try {
            //针对IE或者以IE为内核的浏览器：
            if (agent.contains("MSIE") || agent.contains("Trident")) {
                downloadName = URLEncoder.encode(downloadName, "UTF-8");
            } else {
                //非IE浏览器的处理：
                downloadName = new String(downloadName.getBytes(StandardCharsets.UTF_8), StandardCharsets.ISO_8859_1);
            }
        } catch (Exception e) {
            log.error("系统异常", e);
        }
        response.setHeader("Content-Disposition", "attachment;fileName=\"" + downloadName + "\"");

        //设置压缩流：直接写入response，实现边压缩边下载
        ZipOutputStream zipOs = null;
        //循环将文件写入压缩流
        DataOutputStream os = null;
        //文件
        File file;
        try {
            zipOs = new ZipOutputStream(new BufferedOutputStream(response.getOutputStream()));
            //设置压缩方法
            zipOs.setMethod(ZipOutputStream.DEFLATED);
            //遍历文件信息（主要获取文件名/文件路径等）
            int fileNum = 1;
            for (MatterApplyDatumEntity item : list) {
                try {
                    //      文件存储路径
                    String path = item.getFileUrl();
                    //      压缩文件中每个文件的文件名称
                    String name = item.getFileName();
                    log.info(String.format("batchDownloadFile:[filePath:%s]", path));
                    String rootPath = this.filePath.endsWith("/") ? this.filePath : this.filePath + "/";
                    String filePath = rootPath + path;
                    file = new File(filePath);
                    if (!file.exists()) {
                        throw new RuntimeException("文件不存在");
                    }
                    FileInputStream fs = null;
                    try {
                        //添加ZipEntry，并将ZipEntry中写入文件流
                        zipOs.putNextEntry(new ZipEntry(name));
                        os = new DataOutputStream(zipOs);
                        fs = new FileInputStream(file);
                        byte[] b = new byte[100];
                        int length;
                        //读入需要下载的文件的内容，打包到zip文件
                        while ((length = fs.read(b)) != -1) {
                            os.write(b, 0, length);
                        }
                    } catch (Exception e) {
                        log.error("系统异常", e);
                    } finally {
                        //关闭流
                        assert fs != null;
                        fs.close();
                        zipOs.closeEntry();
                    }

                } catch (Exception e) {
                    log.error(String.format("下载文件出错![%s]", e.getMessage()));
                }
            }
        } catch (Exception e) {
            log.error("系统异常", e);
        } finally {
            //关闭流
            try {
                if (os != null) {
                    os.flush();
                    os.close();
                }
                if (zipOs != null) {
                    zipOs.close();
                }
            } catch (IOException e) {
                log.error("系统异常", e);
            }
        }
    }
}