package com.mortals.xhx.module.site.service;

import com.mortals.framework.common.Rest;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.Context;
import com.mortals.framework.model.PageInfo;
import com.mortals.framework.model.Result;
import com.mortals.framework.service.ICRUDService;
import com.mortals.xhx.module.site.dao.SiteMatterDao;
import com.mortals.xhx.module.site.model.SiteMatterEntity;
/**
* SiteMatterService
*
* 站点事项 service接口
*
* @author zxfei
* @date 2023-03-10
*/
public interface SiteMatterService extends ICRUDService<SiteMatterEntity,Long>{

    SiteMatterDao getDao();
    /**
     * 增加浏览次数
     * @param id
     */
    void addViewsCount(Long id);

    /**
     * 添加事项到单事项
     *
     * @param matterIds
     * @param context
     */
    Rest<String> addToSingle(String matterIds, Context context);

    /**
     * 查找差集子项
     * @param matterQuery
     * @param pageInfo
     * @param context
     * @return
     * @throws AppException
     */
    Result<SiteMatterEntity> findSubList(SiteMatterEntity matterQuery, PageInfo pageInfo, Context context) throws AppException;

}